Codeforces Round #250 (Div. 2)

2024-06-01 20:32
文章标签 codeforces round div 250

本文主要是介绍Codeforces Round #250 (Div. 2),希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

Codeforces Round #250 (Div. 2)

题目链接

A:水题,暴力判断有没有3个两倍长或两倍短的字符串,注意如果有多个答案也是属于C的情况
B:先打出lowbit的表,然后从大到小去组合即可
C:贪心,权值大的点优先拿掉
D:并查集+贪心,先把边都按权值从大到小排序,然后加边,该边可以被用到的次数为左边集合个数乘上右边集合个数,最后答案在除以C2n即可

代码:
A:

#include <stdio.h>
#include <string.h>char str[4][105];int main() {int i, j, flag = 0;char ans = 'C';for (i = 0; i < 4; i++)scanf("%s", str[i]);for (i = 0; i < 4; i++) {int s = 0, l = 0;for (j = 0; j < 4; j++) {if (i == j) continue;int a = strlen(str[i]) - 2;int b = strlen(str[j]) - 2;if (a * 2 <= b)s++;if (a >= b * 2)l++;                }if (s == 3 || l == 3) {ans = i + 'A';flag++;}}if (flag != 1) ans = 'C';printf("%c\n", ans);return 0;
}

B:

#include <stdio.h>
#include <string.h>
#include <algorithm>
using namespace std;const int N = 100001;
int sum, limit, ans[N], an = 0;
int i, j;
struct Low {int lowbit;int num;
} l[N];bool cmp(Low a, Low b) {return a.lowbit > b.lowbit;
}int main() {scanf("%d%d", &sum, &limit);for (i = 1; i < N; i++) {l[i].num = i;l[i].lowbit = (i&(-i));}sort(l + 1, l + N, cmp);for (i = 1; i < N; i++) {if (l[i].num <= limit) {if (sum >= l[i].lowbit) {ans[an++] = l[i].num;sum -= l[i].lowbit;}}if (sum == 0) break;}if (sum != 0) printf("-1\n"); else {printf("%d\n", an);for (int i = 0; i < an - 1; i++)printf("%d ", ans[i]);printf("%d\n", ans[an - 1]);}return 0;
}

C:

#include <stdio.h>
#include <string.h>
#include <vector>
#include <algorithm>
#define max(a,b) ((a)>(b)?(a):(b))
using namespace std;const int N = 1005;
int n, m, vis[N], val[N];
vector<int> g[N];
struct Node {int value;int id;
} node[N];bool cmp(Node a, Node b) {return a.value > b.value;
}int main() {int i, j;scanf("%d%d", &n, &m);for (i = 1; i <= n; i++) {scanf("%d", &node[i].value);node[i].id = i;val[i] = node[i].value;}int u, v;while (m--) {scanf("%d%d", &u, &v);g[u].push_back(v);g[v].push_back(u);}int ans = 0;sort(node + 1, node + 1 + n, cmp);for (i = 1; i <= n; i++) {int u = node[i].id;vis[u] = 1;for (j = 0; j < g[u].size(); j++) {int v = g[u][j];if (vis[v]) continue;ans += val[v];}}printf("%d\n", ans);return 0;
}

D:

#include <stdio.h>
#include <string.h>
#include <algorithm>
using namespace std;const int N = 100005;
int n, m, node[N], parent[N], sum[N];struct Edge {int u, v, w;Edge(int u = 0, int v = 0, int w = 0) {this->u = u; this->v = v; this->w = w;}
} e[N];bool cmp(Edge a, Edge b) {return a.w > b.w;
}int find(int x) {if (x == parent[x]) return x;return parent[x] = find(parent[x]);
}int main() {scanf("%d%d", &n, &m);for (int i = 1; i <= n; i++) {parent[i] = i;sum[i] = 1;scanf("%d", &node[i]);}int u, v;for (int i = 0; i < m; i++) {scanf("%d%d", &u, &v);e[i] = Edge(u, v, min(node[u], node[v]));}sort(e, e + m, cmp);double ans = 0;for (int i = 0; i < m; i++) {int pa = find(e[i].u);int pb = find(e[i].v);if (pa != pb) {ans += (double)e[i].w * sum[pa] * sum[pb];parent[pb] = pa;sum[pa] += sum[pb];}}printf("%.6lf\n", ans * 2 / (n * 1.0 * (n - 1)));return 0;
}

这篇关于Codeforces Round #250 (Div. 2)的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/1022042

相关文章

Codeforces Round #240 (Div. 2) E分治算法探究1

Codeforces Round #240 (Div. 2) E  http://codeforces.com/contest/415/problem/E 2^n个数,每次操作将其分成2^q份,对于每一份内部的数进行翻转(逆序),每次操作完后输出操作后新序列的逆序对数。 图一:  划分子问题。 图二: 分而治之,=>  合并 。 图三: 回溯:

Codeforces Round #261 (Div. 2)小记

A  XX注意最后输出满足条件,我也不知道为什么写的这么长。 #define X first#define Y secondvector<pair<int , int> > a ;int can(pair<int , int> c){return -1000 <= c.X && c.X <= 1000&& -1000 <= c.Y && c.Y <= 1000 ;}int m

Codeforces Beta Round #47 C凸包 (最终写法)

题意慢慢看。 typedef long long LL ;int cmp(double x){if(fabs(x) < 1e-8) return 0 ;return x > 0 ? 1 : -1 ;}struct point{double x , y ;point(){}point(double _x , double _y):x(_x) , y(_y){}point op

Codeforces Round #113 (Div. 2) B 判断多边形是否在凸包内

题目点击打开链接 凸多边形A, 多边形B, 判断B是否严格在A内。  注意AB有重点 。  将A,B上的点合在一起求凸包,如果凸包上的点是B的某个点,则B肯定不在A内。 或者说B上的某点在凸包的边上则也说明B不严格在A里面。 这个处理有个巧妙的方法,只需在求凸包的时候, <=  改成< 也就是说凸包一条边上的所有点都重复点都记录在凸包里面了。 另外不能去重点。 int

Codeforces 482B 线段树

求是否存在这样的n个数; m次操作,每次操作就是三个数 l ,r,val          a[l] & a[l+1] &......&a[r] = val 就是区间l---r上的与的值为val 。 也就是意味着区间[L , R] 每个数要执行 | val 操作  最后判断  a[l] & a[l+1] &......&a[r] 是否= val import ja

CSS实现DIV三角形

本文内容收集来自网络 #triangle-up {width: 0;height: 0;border-left: 50px solid transparent;border-right: 50px solid transparent;border-bottom: 100px solid red;} #triangle-down {width: 0;height: 0;bor

创建一个大的DIV,里面的包含两个DIV是可以自由移动

创建一个大的DIV,里面的包含两个DIV是可以自由移动 <body>         <div style="position: relative; background:#DDF8CF;line-height: 50px"> <div style="text-align: center; width: 100%;padding-top: 0px;"><h3>定&nbsp;位&nbsp;

Codeforces Round 971 (Div. 4) (A~G1)

A、B题太简单,不做解释 C 对于 x y 两个方向,每一个方向至少需要 x / k 向上取整的步数,取最大值。 由于 x 方向先移动,假如 x 方向需要的步数多于 y 方向的步数,那么最后 y 方向的那一步就不需要了,答案减 1 代码 #include <iostream>#include <algorithm>#include <vector>#include <string>

CF#271 (Div. 2) D.(dp)

D. Flowers time limit per test 1.5 seconds memory limit per test 256 megabytes input standard input output standard output 题目链接: http://codeforces.com/contest/474/problem/D We s

CF #278 (Div. 2) B.(暴力枚举+推导公式+数学构造)

B. Candy Boxes time limit per test 1 second memory limit per test 256 megabytes input standard input output standard output 题目链接: http://codeforces.com/contest/488/problem/B There